unit Unit5;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls, Buttons, ExtCtrls, math;

type
  TForm5 = class(TForm)
    Image1: TImage;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    Button1: TButton;
    Label1: TLabel;
    Label2: TLabel;
    TrackBar1: TTrackBar;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Panel1: TPanel;
    procedure Button1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    MB                  : array of array of byte;

  public
    { Public declarations }
    ang,anch,maxim,porc : integer;
  end;

var
  Form5: TForm5;

implementation

uses Unit4, Unit1;

{$R *.dfm}

procedure TForm5.FormCreate(Sender: TObject);
begin

end;

// Muestra Imagen a superponer
procedure TForm5.FormShow(Sender: TObject);
begin
  porc  := 50;
  Image1.Picture.Assign(Form1.Image1.Picture.Bitmap);
end;

// Realiza Superposicin
procedure TForm5.Button1Click(Sender: TObject);
var
  x,y,nx,ny      : integer;
  kk,kx,ky       : single;
  theta, phi     : single;
  xm,ym          : integer;
  cx,cy,arg,ir   : single;
  p1,pp,qq       : integer;
  alf,bet,p2     : single;
begin
  { ---------------  Creamos patron -------------- }
  // ancho y alto  de la imagen a trabajar
  nx := Form1.Image1.Width;
  ny := Form1.Image1.Height;

  // Dimensionamos la Matriz con el patrn
  SetLength(MB,nx,ny);

  // punto medio de la matriz tipo lienzo
  xm := nx div 2;
  ym := ny div 2;

  // vector de onda
  theta := -PI*ang/180;
  phi   := PI/2 + theta;
  kk    := 2*PI/anch;
  kx    := kk*cos(phi);
  ky    := kk*sin(phi);

  for y := -ym to ym-1 do begin
    cy := ky*y;
    for x := -xm to xm-1 do begin
      cx  := kx*x;
      arg := cx+cy;
      ir  := maxim*(1+cos(arg));
      MB[x+xm][y+ym] := round(ir);
    end;
  end;

  { ------------- Hacemos la superposicin ----------- }
  // leemos alpha
  alf := TrackBar1.Position/100;
  bet := 1.0 - alf;

  for y := 0 to ny - 1 do
    for x := 0 to nx - 1 do begin
      p1 := Form1.Image1.Canvas.Pixels[x,y] and $FF;
      p2 := MB[x][y];
      pp := round(alf*p1+bet*p2) and $FF;
      qq := RGB(pp,pp,pp);
      Image1.Canvas.Pixels[x,y] := qq;
    end;

end;

end.
